config/routes.rb
Spree::Core::Engine.routes.draw do
  get '/reviews',  action: :show, controller: 'pages', p: 'reviews', :as => :reviews

  namespace :admin do
    resource :yotpo_settings do
      collection do
        post :upload_past_orders
      end
    end
  end
end

app/models/spree/order_decorator.rb
Spree::Order.class_eval do

  def yotpo_conversion_tracking
    client = YotpoAPI::V1::Client.new
    client.spree(Spree::Core::Engine.routes.url_helpers)
    app_key = Rails.configuration.x.yotpo.app_key
    secret_key = Rails.configuration.x.yotpo.secret_key

    begin
      client.create_order(app_key, secret_key, self)
      Rails.logger.info "Yotpo: Successfully track conversion order: #{self.number}"
    rescue StandardError => e
      Rails.logger.info "Yotpo: Failed track conversion order: #{self.number}"
      Rails.logger.info e
    end
  end
end

Spree::Order.state_machine.after_transition :to => :complete,
                                            :do => :yotpo_conversion_tracking

app/models/spree/product_decorator.rb
Spree::Product.class_eval do
  def yotpo_rich_snippets()
    client = YotpoAPI::V1::Client.new
    app_key = Rails.configuration.x.yotpo.app_key
    expire = (Rails.configuration.x.yotpo.rich_snippets_refresh_time.present? ? Rails.configuration.x.yotpo.rich_snippets_refresh_time : 24.hours)

    begin
      rich_snippets = Rails.cache.fetch("#{cache_key}/yotpo_rich_snippets", expires_in: expire) do
        client.rich_snippets(app_key, id)
      end

      return rich_snippets
    rescue StandardError => e
      Rails.logger.warn "Yotpo: Failed to get rich snippets for product: #{id}"
      Rails.logger.warn e

      return {}
    end
  end

  def yotpo_reviews()
    client = YotpoAPI::V1::Client.new
    app_key = Rails.configuration.x.yotpo.app_key
    expire = (Rails.configuration.x.yotpo.reviews_refresh_time.present? ? Rails.configuration.x.yotpo.reviews_refresh_time : 24.hours)

    begin
      reviews = Rails.cache.fetch("#{cache_key}/yotpo_reviews", expires_in: expire) do
        client.reviews(app_key, id)
      end
      
      return reviews
    rescue StandardError => e
      Rails.logger.warn "Yotpo: Failed to get reviews for product: #{id}"
      Rails.logger.warn e

      return {}
    end
  end
end

app/controllers/spree/admin/yotpo_settings_controller.rb
module Spree
  module Admin
    class YotpoSettingsController < Spree::Admin::BaseController
      PAST_ORDERS_DAYS_BACK = 180

      def edit
      end

      def upload_past_orders(days_in_past: PAST_ORDERS_DAYS_BACK)
        client = YotpoAPI::V1::Client.new
        client.spree(spree)
        app_key = Rails.configuration.x.yotpo.app_key
        secret_key = Rails.configuration.x.yotpo.secret_key

        Spree::Order.where("completed_at > ?", PAST_ORDERS_DAYS_BACK.days.ago).each do |order|
          begin
            client.create_order(app_key, secret_key, order)
            Rails.logger.info "Yotpo: Successfully uploaded order: #{order.number}"
          rescue StandardError => e
            Rails.logger.info "Yotpo: Failed uploading order: #{order.number}"
            Rails.logger.info e
          end
        end

        head :no_content
      end
    end
  end
end

app/views/spree/admin/yotpo_settings/edit.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:yotpo_settings) %>
<% end %>

<%= form_tag admin_yotpo_settings_path, method: :put do %>
  <div id="preferences" data-hook>

    <fieldset class="general no-border-top">

      <div class="row">
        <div class="col-xs-12 col-md-6">
          <%#-------------------------------------------------%>
          <%# Upload past orders                              %>
          <%#-------------------------------------------------%>
          <div class="panel panel-default">
            <div class="panel-heading">
              <h1 class="panel-title"><%= Spree.t(:upload_past_orders)%></h1>
            </div>

            <div class="panel-body">
              <div class="upload-past-orders-warning alert alert-warning">
                <%= Spree.t(:upload_past_orders_message) %>
              </div>
              <div data-hook="yotpo_settings_upload_past_orders">
                <%= button Spree.t(:upload_past_orders), 'ok', 'button', id: "upload_past_orders", data: { disable_with: 'Uploading...' } %>
              </div>
            </div>
          </div>

        </div>
      </div>

    </fieldset>

  </div>

<% end %>

app/views/spree/pages/reviews.html.erb
<% if Rails.configuration.x.yotpo.app_key.present? %>
<% self.title = "Customer Reviews and Testimonials" %>
<% meta_tag :description, 'Reviews and testimonials from our customers mean the world to us. Check out want our customers have to say!' %>
  <main class="main-contents">
    <div class="container">
    <h1 class="title pb-40">Reviews</h1>
      <%= render partial: 'spree/shared/yotpo_reviews_carousel' %>
      <div style="clear: both;"></div>
      <script type="text/javascript">
          (function e(){var e=document.createElement("script");e.type="text/javascript",e.async=!0,
              e.src="//staticw2.yotpo.com/<%= Rails.configuration.x.yotpo.app_key %>/widget.js";var t=document.getElementsByTagName("script")[0];
              t.parentNode.insertBefore(e,t)})();
      </script>
      <div id='yotpo-testimonials-custom-tab'></div>
    </div>
  </main>
<% end %>

app/views/spree/shared/_yotpo_product_show.html.erb
<%= render partial: 'spree/shared/yotpo_star_rating' %>
<%= render partial: 'spree/shared/yotpo_rich_snippets' %>
<%= render partial: 'spree/shared/yotpo_reviews' %>

app/views/spree/shared/_yotpo_reviews.html.erb
<% reviews = @product.yotpo_reviews() %>
<% if reviews.present? %>
<% reviews['response']['reviews'].each do |review| %>
  <span itemprop="review" itemscope itemtype="https://schema.org/Review">
    <span itemprop="reviewRating" itemscope itemtype="https://schema.org/Rating">
      <meta itemprop="ratingValue" content="<%= review['score'] %>" />
    </span>
    <meta itemprop="name" content="<%= review['title'] %>" />
    <span itemprop="author" itemscope itemtype="https://schema.org/Person">
      <meta itemprop="name" content="<%= review['user']['display_name'] %>" />
    </span>
    <meta itemprop="datePublished" content="<%= review['created_at'] %>">
    <meta itemprop="reviewBody" content="<%= review['content'] %>" />
    <span itemprop="publisher" itemscope itemtype="https://schema.org/Organization">
      <meta itemprop="name" content="<%= Rails.application.config.organization %>" />
    </span>
  </span>
<% end %>
<% end %>

app/views/spree/shared/_yotpo_reviews_carousel.html.erb
<div class="yotpo yotpo-reviews-carousel" data-background-color="transparent" data-mode="top_rated" data-type="both" data-count="4" data-show-bottomline="1" data-autoplay-enabled="1" data-autoplay-speed="7000" data-show-navigation="1" data-testimonials-page-enabled="1" data-testimonials-page-text="See All Reviews" data-testimonials-page-link="<%= reviews_url %>">&nbsp;</div>

app/views/spree/shared/_yotpo_reviews_widget.html.erb
<%
  if @product.images.present?
    img_src = @product.images.first.my_cf_image_url("small")
  elsif @product.variant_images.present?
    img_src = @product.variant_images.first.my_cf_image_url("small")
  end
%>
<div class="product-details">
  <ul class="nav nav-tabs" role="tablist">
    <li role="presentation" class="active"><h3 class="reviews">Reviews</h3></li>
  </ul>

  <div class="yotpo yotpo-main-widget"
    data-product-id="<%= @product.id %>"
    data-price="<%= @product.price %>"
    data-currency="USD"
    data-name="<%= @product.name %>"
    data-url="<%= spree.product_url(@product) %>"
    data-image-url="<%= img_src %>"
    data-description="<%= (@product.short_description.present? ? @product.short_description : @product.description) %>">
  </div>
</div>

app/views/spree/shared/_yotpo_rich_snippets.html.erb
<% rich_snippets = @product.yotpo_rich_snippets() %>
<%
  if @product.variants.count == 0
    offer_count = 1
    low_price = @product.price.to_s
    high_price = @product.price.to_s
  else
    offer_count = @product.variants.count
    first = @product.variants.to_a.first
    last = @product.variants.to_a.last
    low_price = @product.variants.first.price.to_s
    high_price = @product.variants.last.price.to_s
  end
%>
<% if rich_snippets.present? && rich_snippets['response']['bottomline']['average_score'].to_i > 0 %>
  <span class="aggregateRating no-display" itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating">
    <meta itemprop="ratingValue" content="<%= rich_snippets['response']['bottomline']['average_score'] %>" />
    <meta itemprop="bestRating" content="5" />
    <meta itemprop="worstRating" content="1" />
    <meta itemprop="reviewCount" content="<%= rich_snippets['response']['bottomline']['total_reviews'] %>" />
  </span>
<% end %>
  <span class="aggregateOffer no-display" itemprop="offers" itemscope itemtype="http://schema.org/AggregateOffer">
    <meta itemprop="lowPrice" content="<%= low_price %>" /> 
    <meta itemprop="highPrice" content="<%= high_price %>" />
    <meta itemprop="offerCount" content="<%= offer_count %>" />
    <meta itemprop="priceCurrency" content="<%= current_currency %>"/>
  </span>
  

app/views/spree/shared/_yotpo_star_rating.html.erb
      <div class="yotpo bottomLine ratings" data-product-id="<%= @product.id %>" data-url="<%= spree.product_url(@product) %>"></div>

app/views/spree/shared/_yotpo_tag.html.erb
<!-- YotPo -->
<script type="text/javascript">
(function e(){var e=document.createElement("script");e.type="text/javascript",e.async=true,e.src="//staticw2.yotpo.com/<%= Rails.configuration.x.yotpo.app_key %>/widget.js";var t=document.getElementsByTagName("script")[0];t.parentNode.insertBefore(e,t)})();
</script>